.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

RichAppend proto pBuff:DWORD,col:DWORD

;**********************************************************************************************************

WIN_WIDTH       equ 320
WIN_HEIGHT      equ 240

IDRICH1         equ 10001

;**********************************************************************************************************

.data
ClassName   db "richtest",0
AppName     db "Richy",0

RichDLL     db "Riched20.dll",0
RichClass   db "RichEdit20A",0

;;some test random strings
nl      db 13,10,0
strS    db "Server: ",0
strC    db "Client: ",0
msg1    db "Hello",13,10,0
msg2    db "May I help you?",13,10,0
msg3    db "Give me root access",13,10,0
msg4    db "I don't think so",0
msg5    db " -- GO AWAY!!",13,10,0
msg6    db "<Disconnected>",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hRichDLL    HMODULE     ?
hRWnd       HWND        ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    push edi
    lea edi,[wc]
    assume edi:ptr WNDCLASSEX
    mov [edi].cbSize,SIZEOF wc
    mov [edi].style,CS_HREDRAW or CS_VREDRAW
    mov [edi].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [edi].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [edi].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [edi].hCursor,eax
    mov [edi].hbrBackground,COLOR_WINDOW+1
    mov [edi].lpszClassName,OFFSET ClassName
    xor eax,eax
    mov [edi].cbClsExtra,eax
    mov [edi].cbWndExtra,eax
    mov [edi].lpszMenuName,eax
    mov [edi].hIconSm,eax
    invoke RegisterClassEx, edi
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea edi,[msg]
        assume edi:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, edi,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, edi
            invoke DispatchMessage, edi
        .ENDW
        mov eax,[edi].wParam
    .ENDIF
    assume edi:nothing
    pop edi
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_SIZE -----------------------------------------------------------------------------------------
    .IF (eax==WM_SIZE)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;width
        shr edx,16      ;height
        invoke MoveWindow, hRWnd,0,0,eax,edx,TRUE
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        ;need to make sure the dll is loaded - so we can access the richedit control
        ;(this only needs to be done once)
        invoke LoadLibrary, ADDR RichDLL
        mov hRichDLL,eax

        ;** create a richedit window
        invoke CreateWindowEx, WS_EX_CLIENTEDGE,ADDR RichClass,NULL,WS_VISIBLE or WS_CHILD or WS_VSCROLL or ES_MULTILINE or ES_READONLY,0,0,0,0,hwnd,IDRICH1,hInstance,NULL
        mov hRWnd,eax

        ;** limit text to 4MB
        invoke SendMessage, hRWnd,EM_EXLIMITTEXT,NULL,0400000h

        ;** set a nicer font
        invoke GetStockObject, DEFAULT_GUI_FONT     ;could also use: SYSTEM_FIXED_FONT, OEM_FIXED_FONT
        invoke SendMessage, hRWnd,WM_SETFONT,eax,TRUE

        ;** print some stuff
        invoke RichAppend, ADDR strC,07f7f7fh   ;grey
        invoke RichAppend, ADDR msg1,0ff0000h   ;blue

        invoke RichAppend, ADDR strS,07f7f7fh   ;grey
        invoke RichAppend, ADDR msg2,07f007fh   ;magenta

        invoke RichAppend, ADDR strC,07f7f7fh   ;grey
        invoke RichAppend, ADDR msg3,0ff0000h   ;blue

        invoke RichAppend, ADDR strS,07f7f7fh   ;grey
        invoke RichAppend, ADDR msg4,07f007fh   ;magenta
        invoke RichAppend, ADDR msg5,00000ffh   ;bright red

        invoke RichAppend, ADDR msg6,0007fffh   ;orange

;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

RichAppend proc pBuff:DWORD,col:DWORD
    LOCAL charrng:CHARRANGE
    LOCAL charfmt:CHARFORMAT
    mov eax,-1
    mov charrng.cpMax,eax
    mov charrng.cpMin,eax
    mov charfmt.cbSize,SIZEOF CHARFORMAT
    mov charfmt.dwMask,CFM_COLOR
    mov eax,col
    mov charfmt.crTextColor,eax
    invoke SendMessage, hRWnd,EM_EXSETSEL,NULL,ADDR charrng
    invoke SendMessage, hRWnd,EM_SETCHARFORMAT,SCF_SELECTION,ADDR charfmt
    invoke SendMessage, hRWnd,EM_REPLACESEL,FALSE,pBuff
    invoke SendMessage, hRWnd,EM_SCROLLCARET,NULL,NULL      ;scroll the text into view
    ret
RichAppend endp

end start
